#include "MyApp.h"

void MyApp::setup()
{
	// Check GLSL version
	const GLubyte* ver;
	ver = glGetString(GL_VERSION); 
	printf("OpenGL version=%s\n",ver);
	ver = glGetString(GL_SHADING_LANGUAGE_VERSION);
	printf("GLSL version=%s\n",ver);
	GLint n;
	glGetIntegerv(GL_MAX_GEOMETRY_OUTPUT_VERTICES_EXT, &n);
	printf("GLSL GL_MAX_GEOMETRY_OUTPUT_VERTICES_EXT=%d\n",n);
	glGetIntegerv(GL_MAX_GEOMETRY_TOTAL_OUTPUT_COMPONENTS_EXT, &n);
	printf("GLSL GL_MAX_GEOMETRY_TOTAL_OUTPUT_COMPONENTS_EXT=%d\n",n);
	
	// Make Shaders
	// GS input: GL_POINTS, GL_LINES, GL_LINES_ADJACENCY_EXT, GL_TRIANGLES, GL_TRIANGLES_ADJACENCY_EXT
	// GS output: GL_POINTS, GL_LINE_STRIP, GL_TRIANGLE_STRIP
	mShader = gl::GlslProg( loadResource( "shBasic.vert" ),
						   loadResource( "shBasic.frag" ),
						   loadResource( "shBasic.geom" ),
						   GL_LINES, GL_POINTS );
	//mShader.bind();
	//mShader.uniform( "alpha", (bool) false );
	//mShader.unbind();
}

//////////////////////////////////////////////
//
// UPDATE
//
void MyApp::update()
{
}


//////////////////////////////////////////////
//
// DRAW
//
void MyApp::draw()
{
	float x, y, z, w, h;
	
	glDisable( GL_DEPTH_TEST );
	glDisable( GL_TEXTURE_2D );
	
	gl::clear();
	gl::color( Color( 1, 1, 0 ) );

	mShader.bind();
	
	w = getWindowWidth() / 6;
	h = getWindowHeight() / 3;
	x = w;
	y = h;
	z = 0;
	
	glLineWidth( 2 );
	glPointSize( 5 );
	glBegin(GL_LINE_STRIP);
	
	glVertex3f(x, y, z);
	x += w;
	y += h;
	glVertex3f(x, y, z);
	x += w;
	y -= h;
	glVertex3f(x, y, z);
	x += w;
	y += h;
	glVertex3f(x, y, z);
	x += w;
	y -= h;
	glVertex3f(x, y, z);
	
	glEnd();
	
	mShader.unbind();
}




CINDER_APP_BASIC( MyApp, RendererGl )
